--- a/main/dns_naptr.c
+++ b/main/dns_naptr.c
@@ -475,7 +475,7 @@
 		return NULL;
 	}
 
-	naptr = ast_calloc(1, sizeof(*naptr) + size + flags_size + 1 + services_size + 1 + regexp_size + 1 + replacement_size + 1);
+	naptr = ast_calloc(1, sizeof(*naptr) + size + flags_size + 1 + services_size + 1 + regexp_size + 1 + strlen(replacement) + 1);
 	if (!naptr) {
 		return NULL;
 	}
--- a/main/dns_srv.c
+++ b/main/dns_srv.c
@@ -83,7 +83,7 @@
 		return NULL;
 	}
 
-	srv = ast_calloc(1, sizeof(*srv) + size + host_size + 1);
+	srv = ast_calloc(1, sizeof(*srv) + size + strlen(host) + 1);
 	if (!srv) {
 		return NULL;
 	}
@@ -94,7 +94,6 @@
 
 	srv->host = srv->data + size;
 	strcpy((char *)srv->host, host); /* SAFE */
-	((char *)srv->host)[host_size] = '\0';
 
 	srv->generic.data_ptr = srv->data;
 

